Hex Artifact Content

Artifact 84b7ccd5bbfa4bd2af92e0f6998b008184aafde1:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 54 5a 3d 55 54 43 0a 65 78 70  bash..TZ=UTC.exp
0020: 6f 72 74 20 54 5a 0a 0a 74 61 72 67 65 74 6d 6f  ort TZ..targetmo
0030: 64 65 3d 27 69 6e 73 74 61 6c 6c 27 0a 69 66 20  de='install'.if 
0040: 5b 20 22 24 31 22 20 3d 3d 20 27 2d 2d 63 70 69  [ "$1" == '--cpi
0050: 6f 27 20 5d 3b 20 74 68 65 6e 0a 09 74 61 72 67  o' ]; then..targ
0060: 65 74 6d 6f 64 65 3d 27 61 72 63 68 69 76 65 27  etmode='archive'
0070: 0a 0a 09 73 68 69 66 74 0a 66 69 0a 0a 70 6b 67  ...shift.fi..pkg
0080: 3d 22 24 28 65 63 68 6f 20 22 24 31 22 20 7c 20  ="$(echo "$1" | 
0090: 73 65 64 20 27 73 40 2f 2a 24 40 40 3b 73 40 5e  sed 's@/*$@@;s@^
00a0: 5c 2e 2a 2f 2a 40 40 27 29 22 0a 0a 69 66 20 5b  \.*/*@@')"..if [
00b0: 20 2d 7a 20 22 24 7b 70 6b 67 7d 22 20 5d 3b 20   -z "${pkg}" ]; 
00c0: 74 68 65 6e 0a 09 65 63 68 6f 20 22 55 73 61 67  then..echo "Usag
00d0: 65 3a 20 62 75 69 6c 64 20 5b 2d 2d 63 70 69 6f  e: build [--cpio
00e0: 5d 20 3c 70 61 63 6b 61 67 65 3e 22 20 32 3e 26  ] <package>" 2>&
00f0: 31 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 66  1...exit 1.fi..f
0100: 75 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e  unction determin
0110: 65 4f 73 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d  eOsArch() {..os=
0120: 22 24 28 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64  "$(uname -s | dd
0130: 20 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64   conv=lcase 2>/d
0140: 65 76 2f 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d  ev/null)"..arch=
0150: 22 24 28 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64  "$(uname -m | dd
0160: 20 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64   conv=lcase 2>/d
0170: 65 76 2f 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65  ev/null)"...case
0180: 20 22 24 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09   "${arch}" in...
0190: 69 3f 38 36 29 0a 09 09 09 61 72 63 68 3d 27 69  i?86)....arch='i
01a0: 78 38 36 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63  x86'....;;..esac
01b0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74  .}..function det
01c0: 65 72 6d 69 6e 65 50 72 65 66 69 78 28 29 20 7b  erminePrefix() {
01d0: 0a 09 64 65 74 65 72 6d 69 6e 65 4f 73 41 72 63  ..determineOsArc
01e0: 68 0a 0a 09 70 72 65 66 69 78 73 75 66 66 69 78  h...prefixsuffix
01f0: 3d 22 24 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24  ="${pkg}/${os}-$
0200: 7b 61 72 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e  {arch}/${version
0210: 7d 22 0a 09 70 72 65 66 69 78 3d 22 2f 6f 70 74  }"..prefix="/opt
0220: 2f 61 70 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d  /appfs/${domain}
0230: 2f 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d  /${prefixsuffix}
0240: 22 0a 09 64 65 73 74 64 69 72 3d 22 24 28 70 77  "..destdir="$(pw
0250: 64 29 2f 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72  d)/INST"...mkdir
0260: 20 22 24 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c   "${destdir}" ||
0270: 20 64 69 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e   die.}..function
0280: 20 70 72 65 63 6f 6e 66 69 67 75 72 65 28 29 20   preconfigure() 
0290: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
02a0: 20 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 28 29   postconfigure()
02b0: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
02c0: 6e 20 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  n configure() {.
02d0: 09 67 6c 69 62 63 76 65 72 73 3d 32 2e 32 30 0a  .glibcvers=2.20.
02e0: 09 67 6c 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f  .glibcdir="/opt/
02f0: 61 70 70 66 73 2f 63 6f 72 65 2e 61 70 70 66 73  appfs/core.appfs
0300: 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62  .rkeene.org/glib
0310: 63 2f 70 6c 61 74 66 6f 72 6d 2f 24 7b 67 6c 69  c/platform/${gli
0320: 62 63 76 65 72 73 7d 22 0a 09 64 79 6e 6c 69 6e  bcvers}"..dynlin
0330: 6b 65 72 3d 22 24 28 6c 73 20 22 24 7b 67 6c 69  ker="$(ls "${gli
0340: 62 63 64 69 72 7d 22 2f 6c 69 62 2f 6c 64 2d 6c  bcdir}"/lib/ld-l
0350: 69 6e 75 78 2a 2e 73 6f 2e 2a 20 7c 20 74 61 69  inux*.so.* | tai
0360: 6c 20 2d 6e 20 31 29 22 0a 0a 09 43 46 4c 41 47  l -n 1)"...CFLAG
0370: 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d  S="-I${glibcdir}
0380: 2f 69 6e 63 6c 75 64 65 22 0a 09 43 50 50 46 4c  /include"..CPPFL
0390: 41 47 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69  AGS="-I${glibcdi
03a0: 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 4c 44 46  r}/include"..LDF
03b0: 4c 41 47 53 3d 22 2d 57 6c 2c 2d 2d 72 70 61 74  LAGS="-Wl,--rpat
03c0: 68 2c 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69  h,${glibcdir}/li
03d0: 62 20 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d  b -Wl,--dynamic-
03e0: 6c 69 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b  linker,${dynlink
03f0: 65 72 7d 22 0a 09 65 78 70 6f 72 74 20 43 46 4c  er}"..export CFL
0400: 41 47 53 20 43 50 50 46 4c 41 47 53 20 4c 44 46  AGS CPPFLAGS LDF
0410: 4c 41 47 53 0a 0a 09 2e 2f 63 6f 6e 66 69 67 75  LAGS..../configu
0420: 72 65 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 70  re --prefix="${p
0430: 72 65 66 69 78 7d 22 20 2d 2d 73 79 73 63 6f 6e  refix}" --syscon
0440: 66 64 69 72 3d 2f 65 74 63 20 2d 2d 6c 6f 63 61  fdir=/etc --loca
0450: 6c 73 74 61 74 65 64 69 72 3d 2f 76 61 72 0a 7d  lstatedir=/var.}
0460: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 62 75  ..function prebu
0470: 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ild() {..:.}..fu
0480: 6e 63 74 69 6f 6e 20 70 6f 73 74 62 75 69 6c 64  nction postbuild
0490: 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74  () {..:.}..funct
04a0: 69 6f 6e 20 62 75 69 6c 64 28 29 20 7b 0a 09 67  ion build() {..g
04b0: 72 65 70 20 22 44 45 53 54 44 49 52 22 20 4d 61  rep "DESTDIR" Ma
04c0: 6b 65 66 69 6c 65 20 3e 2f 64 65 76 2f 6e 75 6c  kefile >/dev/nul
04d0: 6c 20 7c 7c 20 64 69 65 20 22 44 6f 6e 27 74 20  l || die "Don't 
04e0: 6b 6e 6f 77 20 68 6f 77 20 74 6f 20 62 75 69 6c  know how to buil
04f0: 64 20 74 68 69 73 20 73 6f 66 74 77 61 72 65 22  d this software"
0500: 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a 66 75 6e 63 74  ...make.}..funct
0510: 69 6f 6e 20 70 72 65 69 6e 73 74 61 6c 6c 28 29  ion preinstall()
0520: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
0530: 6e 20 70 6f 73 74 69 6e 73 74 61 6c 6c 28 29 20  n postinstall() 
0540: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
0550: 20 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 6d 61   install() {..ma
0560: 6b 65 20 69 6e 73 74 61 6c 6c 20 44 45 53 54 44  ke install DESTD
0570: 49 52 3d 22 24 7b 64 65 73 74 64 69 72 7d 22 0a  IR="${destdir}".
0580: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6c 65 61  }..function clea
0590: 6e 75 70 28 29 20 7b 0a 09 63 64 20 22 24 7b 77  nup() {..cd "${w
05a0: 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  orkdir}" || exit
05b0: 20 31 0a 09 63 64 20 2e 2e 20 7c 7c 20 65 78 69   1..cd .. || exi
05c0: 74 20 31 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77  t 1..rm -rf "${w
05d0: 6f 72 6b 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63  orkdir}".}..func
05e0: 74 69 6f 6e 20 64 69 65 28 29 20 7b 0a 09 6c 6f  tion die() {..lo
05f0: 63 61 6c 20 6d 65 73 73 61 67 65 0a 0a 09 6d 65  cal message...me
0600: 73 73 61 67 65 3d 22 24 31 22 0a 0a 09 69 66 20  ssage="$1"...if 
0610: 5b 20 2d 6e 20 22 24 7b 6d 65 73 73 61 67 65 7d  [ -n "${message}
0620: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f  " ]; then...echo
0630: 20 22 65 72 72 6f 72 3a 20 24 7b 6d 65 73 73 61   "error: ${messa
0640: 67 65 7d 22 20 3e 26 32 0a 09 66 69 0a 0a 09 63  ge}" >&2..fi...c
0650: 6c 65 61 6e 75 70 0a 0a 09 65 78 69 74 20 31 0a  leanup...exit 1.
0660: 7d 0a 0a 73 63 72 69 70 74 64 69 72 3d 22 24 28  }..scriptdir="$(
0670: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
0680: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
0690: 26 26 20 70 77 64 29 22 0a 69 66 20 5b 20 2d 7a  && pwd)".if [ -z
06a0: 20 22 24 7b 73 63 72 69 70 74 64 69 72 7d 22 20   "${scriptdir}" 
06b0: 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 55  ]; then..echo "U
06c0: 6e 61 62 6c 65 20 74 6f 20 6c 6f 63 61 74 65 20  nable to locate 
06d0: 73 63 72 69 70 74 20 64 69 72 65 63 74 6f 72 79  script directory
06e0: 22 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66  " >&2...exit 1.f
06f0: 69 0a 0a 63 64 20 22 24 7b 73 63 72 69 70 74 64  i..cd "${scriptd
0700: 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a  ir}" || exit 1..
0710: 69 66 20 5b 20 2d 66 20 27 62 75 69 6c 64 2e 63  if [ -f 'build.c
0720: 6f 6e 66 27 20 5d 3b 20 74 68 65 6e 0a 09 2e 20  onf' ]; then... 
0730: 27 62 75 69 6c 64 2e 63 6f 6e 66 27 0a 66 69 0a  'build.conf'.fi.
0740: 0a 69 66 20 5b 20 2d 64 20 22 70 6b 67 73 2f 24  .if [ -d "pkgs/$
0750: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
0760: 70 6b 67 64 69 72 3d 22 70 6b 67 73 2f 24 7b 70  pkgdir="pkgs/${p
0770: 6b 67 7d 22 0a 09 70 6b 67 66 69 6c 65 3d 22 24  kg}"..pkgfile="$
0780: 7b 70 6b 67 64 69 72 7d 2f 69 6e 66 6f 22 0a 65  {pkgdir}/info".e
0790: 6c 73 65 0a 09 70 6b 67 66 69 6c 65 3d 22 70 6b  lse..pkgfile="pk
07a0: 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67 64  gs/${pkg}"..pkgd
07b0: 69 72 3d 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a  ir="${pkgfile}".
07c0: 66 69 0a 0a 69 66 20 5b 20 21 20 2d 65 20 22 24  fi..if [ ! -e "$
07d0: 7b 70 6b 67 66 69 6c 65 7d 22 20 5d 3b 20 74 68  {pkgfile}" ]; th
07e0: 65 6e 0a 09 65 63 68 6f 20 22 49 6e 76 61 6c 69  en..echo "Invali
07f0: 64 20 70 61 63 6b 61 67 65 2e 22 20 3e 26 32 0a  d package." >&2.
0800: 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 70 6b 67  ..exit 1.fi..pkg
0810: 64 61 74 65 3d 22 24 28 66 6f 72 20 61 72 74 69  date="$(for arti
0820: 66 61 63 74 20 69 6e 20 24 28 66 69 6e 64 20 22  fact in $(find "
0830: 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65  ${pkgdir}" -type
0840: 20 66 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72   f -print0 | xar
0850: 67 73 20 2d 6e 20 31 20 2d 30 20 66 6f 73 73 69  gs -n 1 -0 fossi
0860: 6c 20 66 69 6e 66 6f 20 2d 2d 6c 69 6d 69 74 20  l finfo --limit 
0870: 31 20 2d 2d 77 69 64 74 68 20 30 20 32 3e 2f 64  1 --width 0 2>/d
0880: 65 76 2f 6e 75 6c 6c 20 7c 20 67 72 65 70 20 27  ev/null | grep '
0890: 5e 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d  ^[0-9][0-9][0-9]
08a0: 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d  [0-9]-[0-9][0-9]
08b0: 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 20 27 20 7c 20  -[0-9][0-9] ' | 
08c0: 73 65 64 20 27 73 40 5e 5b 5e 20 5d 2a 20 5c 5b  sed 's@^[^ ]* \[
08d0: 40 40 3b 73 40 5c 5d 2e 2a 40 40 27 20 7c 20 73  @@;s@\].*@@' | s
08e0: 6f 72 74 20 2d 75 29 3b 20 64 6f 20 66 6f 73 73  ort -u); do foss
08f0: 69 6c 20 69 6e 66 6f 20 22 24 7b 61 72 74 69 66  il info "${artif
0900: 61 63 74 7d 22 20 7c 20 61 77 6b 20 27 2f 5e 75  act}" | awk '/^u
0910: 75 69 64 3a 2f 7b 20 70 72 69 6e 74 20 24 33 20  uid:/{ print $3 
0920: 24 34 20 7d 27 20 7c 20 73 65 64 20 27 73 40 5b  $4 }' | sed 's@[
0930: 2d 3a 5d 40 40 67 3b 73 40 2e 2e 24 40 5c 2e 26  -:]@@g;s@..$@\.&
0940: 40 27 3b 20 64 6f 6e 65 20 7c 20 73 6f 72 74 20  @'; done | sort 
0950: 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22  -n | tail -n 1)"
0960: 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64  .if [ -z "${pkgd
0970: 61 74 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 70  ate}" ]; then..p
0980: 6b 67 64 61 74 65 3d 22 24 28 66 69 6e 64 20 22  kgdate="$(find "
0990: 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65  ${pkgdir}" -type
09a0: 20 66 20 2d 70 72 69 6e 74 66 20 27 25 54 59 25   f -printf '%TY%
09b0: 54 6d 25 54 64 25 54 48 25 54 4d 2e 25 54 53 5c  Tm%Td%TH%TM.%TS\
09c0: 6e 27 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c  n' 2>/dev/null |
09d0: 20 63 75 74 20 2d 66 20 31 2d 32 20 2d 64 20 27   cut -f 1-2 -d '
09e0: 2e 27 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74  .' | sort -n | t
09f0: 61 69 6c 20 2d 6e 20 31 29 22 0a 66 69 0a 0a 2e  ail -n 1)".fi...
0a00: 20 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 0a 61   "${pkgfile}"..a
0a10: 72 63 68 69 76 65 64 69 72 3d 22 24 28 70 77 64  rchivedir="$(pwd
0a20: 29 2f 41 52 43 48 49 56 45 22 0a 77 6f 72 6b 64  )/ARCHIVE".workd
0a30: 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 24 24 7b  ir="workdir-$$${
0a40: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
0a50: 24 7b 52 41 4e 44 4f 4d 7d 22 0a 73 72 63 66 69  ${RANDOM}".srcfi
0a60: 6c 65 3d 22 24 7b 61 72 63 68 69 76 65 64 69 72  le="${archivedir
0a70: 7d 2f 24 7b 70 6b 67 7d 22 0a 6d 6b 64 69 72 20  }/${pkg}".mkdir 
0a80: 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d 22 20  "${archivedir}" 
0a90: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
0aa0: 76 2f 6e 75 6c 6c 0a 6d 6b 64 69 72 20 22 24 7b  v/null.mkdir "${
0ab0: 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69  workdir}" || exi
0ac0: 74 20 31 0a 63 64 20 22 24 7b 77 6f 72 6b 64 69  t 1.cd "${workdi
0ad0: 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 77 6f  r}" || exit 1.wo
0ae0: 72 6b 64 69 72 3d 22 24 28 70 77 64 29 22 0a 0a  rkdir="$(pwd)"..
0af0: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 73 72 63  if [ ! -e "${src
0b00: 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  file}" ]; then..
0b10: 23 20 44 6f 77 6e 6c 6f 61 64 0a 09 23 23 20 43  # Download..## C
0b20: 6c 65 61 6e 75 70 0a 09 72 6d 20 2d 66 20 73 72  leanup..rm -f sr
0b30: 63 2e 6e 65 77 20 73 72 63 0a 0a 09 23 23 20 46  c.new src...## F
0b40: 65 74 63 68 20 66 69 6c 65 0a 09 77 67 65 74 20  etch file..wget 
0b50: 2d 4f 20 73 72 63 2e 6e 65 77 20 22 24 7b 75 72  -O src.new "${ur
0b60: 6c 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09  l}" || exit 1...
0b70: 23 23 20 56 65 72 69 66 79 20 73 69 67 6e 61 74  ## Verify signat
0b80: 75 72 65 0a 09 73 72 63 5f 73 68 61 32 35 36 3d  ure..src_sha256=
0b90: 22 24 28 6f 70 65 6e 73 73 6c 20 73 68 61 32 35  "$(openssl sha25
0ba0: 36 20 27 73 72 63 2e 6e 65 77 27 20 7c 20 73 65  6 'src.new' | se
0bb0: 64 20 27 73 40 5e 2e 2a 3d 20 40 40 27 29 22 0a  d 's@^.*= @@')".
0bc0: 09 69 66 20 5b 20 22 24 7b 73 72 63 5f 73 68 61  .if [ "${src_sha
0bd0: 32 35 36 7d 22 20 21 3d 20 22 24 7b 73 68 61 32  256}" != "${sha2
0be0: 35 36 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65  56}" ]; then...e
0bf0: 63 68 6f 20 22 53 48 41 32 35 36 20 6d 69 73 6d  cho "SHA256 mism
0c00: 61 74 63 68 3a 20 20 44 6f 77 6e 6c 6f 61 64 65  atch:  Downloade
0c10: 64 3a 20 24 7b 73 72 63 5f 73 68 61 32 35 36 7d  d: ${src_sha256}
0c20: 20 21 3d 20 45 78 70 65 63 74 65 64 3a 20 24 7b   != Expected: ${
0c30: 73 68 61 32 35 36 7d 22 20 3e 26 32 0a 0a 09 09  sha256}" >&2....
0c40: 65 78 69 74 20 31 0a 09 66 69 0a 0a 09 23 23 20  exit 1..fi...## 
0c50: 4d 6f 76 65 20 66 69 6c 65 20 69 6e 74 6f 20 70  Move file into p
0c60: 6c 61 63 65 0a 09 6d 76 20 73 72 63 2e 6e 65 77  lace..mv src.new
0c70: 20 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f   "${archivedir}/
0c80: 24 7b 70 6b 67 7d 22 0a 66 69 0a 0a 23 20 44 65  ${pkg}".fi..# De
0c90: 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76 65  compress archive
0ca0: 0a 23 23 20 44 65 74 65 72 6d 69 6e 65 20 74 79  .## Determine ty
0cb0: 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a 63 61  pe of archive.ca
0cc0: 73 65 20 22 24 7b 75 72 6c 7d 22 20 69 6e 0a 09  se "${url}" in..
0cd0: 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74 61 72 2e 78  *.tar.xz|*.tar.x
0ce0: 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29 0a 09 09 64  z'?'*|*.txz)...d
0cf0: 65 63 6f 6d 70 72 65 73 73 3d 27 78 7a 27 0a 09  ecompress='xz'..
0d00: 09 3b 3b 0a 09 2a 2e 74 61 72 2e 67 7a 7c 2a 2e  .;;..*.tar.gz|*.
0d10: 74 61 72 2e 67 7a 27 3f 27 2a 7c 2a 2e 74 67 7a  tar.gz'?'*|*.tgz
0d20: 29 0a 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  )...decompress='
0d30: 67 7a 69 70 27 0a 09 09 3b 3b 0a 09 2a 2e 74 61  gzip'...;;..*.ta
0d40: 72 2e 62 7a 32 7c 2a 2e 74 61 72 2e 62 7a 32 27  r.bz2|*.tar.bz2'
0d50: 3f 27 2a 7c 2a 2e 74 62 7a 32 29 0a 09 09 64 65  ?'*|*.tbz2)...de
0d60: 63 6f 6d 70 72 65 73 73 3d 27 62 7a 69 70 32 27  compress='bzip2'
0d70: 0a 09 09 3b 3b 0a 09 2a 2e 7a 69 70 7c 2a 2e 7a  ...;;..*.zip|*.z
0d80: 69 70 27 3f 27 2a 29 0a 09 09 64 65 63 6f 6d 70  ip'?'*)...decomp
0d90: 72 65 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 3b  ress='unzip'...;
0da0: 3b 0a 09 2a 29 0a 09 09 65 63 68 6f 20 22 55 6e  ;..*)...echo "Un
0db0: 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69 6f  known compressio
0dc0: 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c 7d  n method: ${url}
0dd0: 22 20 3e 26 32 0a 0a 09 09 65 78 69 74 20 31 0a  " >&2....exit 1.
0de0: 09 09 3b 3b 0a 65 73 61 63 0a 0a 23 23 20 44 6f  ..;;.esac..## Do
0df0: 20 64 65 63 6f 6d 70 72 65 73 73 69 6f 6e 0a 63   decompression.c
0e00: 61 73 65 20 22 24 7b 64 65 63 6f 6d 70 72 65 73  ase "${decompres
0e10: 73 7d 22 20 69 6e 0a 09 75 6e 7a 69 70 29 0a 09  s}" in..unzip)..
0e20: 09 75 6e 7a 69 70 20 22 24 7b 73 72 63 66 69 6c  .unzip "${srcfil
0e30: 65 7d 22 20 7c 7c 20 64 69 65 20 27 55 6e 61 62  e}" || die 'Unab
0e40: 6c 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73  le to uncompress
0e50: 20 61 72 63 68 69 76 65 27 0a 09 09 3b 3b 0a 09   archive'...;;..
0e60: 2a 29 0a 09 09 22 24 7b 64 65 63 6f 6d 70 72 65  *)..."${decompre
0e70: 73 73 7d 22 20 2d 64 63 20 22 24 7b 73 72 63 66  ss}" -dc "${srcf
0e80: 69 6c 65 7d 22 20 7c 20 74 61 72 20 2d 78 66 20  ile}" | tar -xf 
0e90: 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c 65  - || die 'Unable
0ea0: 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20 61   to uncompress a
0eb0: 72 63 68 69 76 65 27 0a 09 09 3b 3b 0a 65 73 61  rchive'...;;.esa
0ec0: 63 0a 0a 23 23 20 43 6c 65 61 6e 75 70 20 73 6f  c..## Cleanup so
0ed0: 75 72 63 65 0a 72 6d 20 2d 66 20 73 72 63 0a 0a  urce.rm -f src..
0ee0: 23 20 49 66 20 77 65 20 6a 75 73 74 20 68 61 76  # If we just hav
0ef0: 65 20 6f 6e 65 20 64 69 72 65 63 74 6f 72 79 2c  e one directory,
0f00: 20 75 73 65 20 74 68 61 74 20 64 69 72 65 63 74   use that direct
0f10: 6f 72 79 0a 64 69 72 3d 22 24 28 65 63 68 6f 20  ory.dir="$(echo 
0f20: 2a 29 22 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64  *)".if [ -e "${d
0f30: 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76  ir}" ]; then..mv
0f40: 20 22 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69   "${dir}"/* ..fi
0f50: 0a 0a 23 20 53 74 61 72 74 20 6c 6f 67 67 69 6e  ..# Start loggin
0f60: 67 0a 73 65 74 20 2d 78 0a 0a 23 20 44 65 74 65  g.set -x..# Dete
0f70: 72 6d 69 6e 65 20 70 72 6f 70 65 72 74 69 65 73  rmine properties
0f80: 0a 64 65 74 65 72 6d 69 6e 65 50 72 65 66 69 78  .determinePrefix
0f90: 0a 0a 23 20 53 74 61 72 74 20 74 68 65 20 62 75  ..# Start the bu
0fa0: 69 6c 64 0a 70 72 65 63 6f 6e 66 69 67 75 72 65  ild.preconfigure
0fb0: 20 7c 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66   || die 'preconf
0fc0: 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 63 6f  igure failed'.co
0fd0: 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27  nfigure || die '
0fe0: 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64  configure failed
0ff0: 27 0a 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20  '.postconfigure 
1000: 7c 7c 20 64 69 65 20 27 70 6f 73 74 63 6f 6e 66  || die 'postconf
1010: 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 0a 70  igure failed'..p
1020: 72 65 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  rebuild || die '
1030: 70 72 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27  prebuild failed'
1040: 0a 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 62  .build || die 'b
1050: 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f 73  uild failed'.pos
1060: 74 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70  tbuild || die 'p
1070: 6f 73 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27  ostbuild failed'
1080: 0a 0a 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20  ..preinstall || 
1090: 64 69 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20  die 'preinstall 
10a0: 66 61 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20  failed'.install 
10b0: 7c 7c 20 64 69 65 20 27 69 6e 73 74 61 6c 6c 20  || die 'install 
10c0: 66 61 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74  failed'.postinst
10d0: 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74  all || die 'post
10e0: 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a  install failed'.
10f0: 0a 28 0a 09 63 61 73 65 20 22 24 7b 74 61 72 67  .(..case "${targ
1100: 65 74 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69 6e  etmode}" in...in
1110: 73 74 61 6c 6c 29 0a 09 09 09 61 70 70 64 69 72  stall)....appdir
1120: 3d 22 24 28 61 70 70 66 73 69 6e 73 74 61 6c 6c  ="$(appfsinstall
1130: 64 69 72 29 2f 24 7b 70 72 65 66 69 78 73 75 66  dir)/${prefixsuf
1140: 66 69 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20 2d  fix}"....mkdir -
1150: 70 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09  p "${appdir}"...
1160: 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d  ..cd "${destdir}
1170: 2f 24 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20 65  /${prefix}" || e
1180: 78 69 74 20 31 0a 0a 09 09 09 63 70 20 2d 72 70  xit 1.....cp -rp
1190: 20 2a 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 09   * "${appdir}"..
11a0: 09 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72  ..find "${appdir
11b0: 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72  }" -print0 | xar
11c0: 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20 22  gs -0 touch -t "
11d0: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
11e0: 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20  ind "${appdir}" 
11f0: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
1200: 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22  -0 touch -m -t "
1210: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
1220: 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20  ind "${appdir}" 
1230: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
1240: 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22  -0 touch -a -t "
1250: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 3b  ${pkgdate}"....;
1260: 3b 0a 09 09 61 72 63 68 69 76 65 29 0a 09 09 09  ;...archive)....
1270: 61 72 63 68 69 76 65 66 69 6c 65 3d 22 24 7b 73  archivefile="${s
1280: 63 72 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67 7d  criptdir}/${pkg}
1290: 2d 24 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65 63  -${version}-$(ec
12a0: 68 6f 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20  ho "${pkgdate}" 
12b0: 7c 20 73 65 64 20 27 73 40 5c 2e 40 40 67 27 29  | sed 's@\.@@g')
12c0: 2d 24 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22  -${domain}.cpio"
12d0: 0a 09 09 09 63 64 20 22 24 7b 64 65 73 74 64 69  ....cd "${destdi
12e0: 72 7d 2f 24 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f  r}/${prefix}/../
12f0: 2e 2e 2f 2e 2e 22 20 7c 7c 20 65 78 69 74 20 31  ../.." || exit 1
1300: 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66  ....find "${pref
1310: 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e  ixsuffix}" -prin
1320: 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f  t0 | xargs -0 to
1330: 75 63 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74  uch -t "${pkgdat
1340: 65 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70  e}"....find "${p
1350: 72 65 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70  refixsuffix}" -p
1360: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
1370: 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b   touch -m -t "${
1380: 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e  pkgdate}"....fin
1390: 64 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69  d "${prefixsuffi
13a0: 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61  x}" -print0 | xa
13b0: 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20  rgs -0 touch -a 
13c0: 2d 74 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a  -t "${pkgdate}".
13d0: 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69  ...find "${prefi
13e0: 78 73 75 66 66 69 78 7d 22 20 7c 20 73 6f 72 74  xsuffix}" | sort
13f0: 20 7c 20 63 70 69 6f 20 2d 2d 6f 77 6e 65 72 20   | cpio --owner 
1400: 30 3a 30 20 2d 48 20 6e 65 77 63 20 2d 6f 20 3e  0:0 -H newc -o >
1410: 20 22 24 7b 61 72 63 68 69 76 65 66 69 6c 65 7d   "${archivefile}
1420: 22 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 29 20  "....;;..esac.) 
1430: 7c 7c 20 64 69 65 20 27 66 69 6e 61 6c 20 69 6e  || die 'final in
1440: 73 74 61 6c 6c 61 74 69 6f 6e 20 66 61 69 6c 65  stallation faile
1450: 64 27 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65 78 69  d'..cleanup..exi
1460: 74 20 30 0a                                      t 0.